// Part of ImGui Bundle - MIT License - Copyright (c) 2022-2023 Pascal Thomet - https://github.com/pthom/imgui_bundle
#include <pybind11/pybind11.h>

#include "imspinner/imspinner.h"  // Change this include to the library you are binding

namespace py = pybind11;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// <litgen_glue_code>  // Autogenerated code below! Do not edit!

// </litgen_glue_code> // Autogenerated code end
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



void py_init_module_imspinner(py::module& m)
{
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    // <litgen_pydef> // Autogenerated code below! Do not edit!
    ////////////////////    <generated_from:imspinner.h>    ////////////////////
    // #ifndef _IMSPINNER_H_
    //


    py::enum_<ImSpinner::SpinnerTypeT>(m, "SpinnerTypeT", py::arithmetic(), "")
        .value("e_st_rainbow", ImSpinner::e_st_rainbow, "")
        .value("e_st_angle", ImSpinner::e_st_angle, "")
        .value("e_st_dots", ImSpinner::e_st_dots, "")
        .value("e_st_ang", ImSpinner::e_st_ang, "")
        .value("e_st_count", ImSpinner::e_st_count, "");


    m.def("spinner_rainbow",
        ImSpinner::SpinnerRainbow, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color"), py::arg("speed"));

    m.def("spinner_ang",
        ImSpinner::SpinnerAng, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI);

    m.def("spinner_clock",
        ImSpinner::SpinnerClock, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f);

    m.def("spinner_pulsar",
        ImSpinner::SpinnerPulsar, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("bg") = 0xffffff80, py::arg("speed") = 2.8f, py::arg("sequence") = true);

    m.def("spinner_double_fade_pulsar",
        ImSpinner::SpinnerDoubleFadePulsar, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("bg") = 0xffffff80, py::arg("speed") = 2.8f);

    m.def("spinner_twin_pulsar",
        ImSpinner::SpinnerTwinPulsar, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("rings") = 2);

    m.def("spinner_fade_pulsar",
        ImSpinner::SpinnerFadePulsar, py::arg("label"), py::arg("radius"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("rings") = 2);

    m.def("spinner_dots",
        ImSpinner::SpinnerDots, py::arg("label"), py::arg("nextdot"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 12, py::arg("mdots") = 6, py::arg("minth") = -1.f);

    m.def("spinner_v_dots",
        ImSpinner::SpinnerVDots, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 12, py::arg("mdots") = 6);

    m.def("spinner_bounce_dots",
        ImSpinner::SpinnerBounceDots, py::arg("label"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 3);

    m.def("spinner_fade_dots",
        ImSpinner::SpinnerFadeDots, py::arg("label"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 3);

    m.def("spinner_scale_dots",
        ImSpinner::SpinnerScaleDots, py::arg("label"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 3);

    m.def("spinner_moving_dots",
        ImSpinner::SpinnerMovingDots, py::arg("label"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 3);

    m.def("spinner_rotate_dots",
        ImSpinner::SpinnerRotateDots, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 2);

    m.def("spinner_twin_ang",
        ImSpinner::SpinnerTwinAng, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("thickness"), py::arg("color1") = ImColor(0xffffffff), py::arg("color2") = ImColor(0xff0000ff), py::arg("speed") = 2.8f);

    m.def("spinner_filling",
        ImSpinner::SpinnerFilling, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color1") = ImColor(0xffffffff), py::arg("color2") = ImColor(0xff0000ff), py::arg("speed") = 2.8f);

    m.def("spinner_topup",
        ImSpinner::SpinnerTopup, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("color") = ImColor(0xff0000ff), py::arg("fg") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffffff), py::arg("speed") = 2.8f);

    m.def("spinner_twin_ang180",
        ImSpinner::SpinnerTwinAng180, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("thickness"), py::arg("color1") = ImColor(0xffffffff), py::arg("color2") = ImColor(0xff0000ff), py::arg("speed") = 2.8f);

    m.def("spinner_twin_ang360",
        ImSpinner::SpinnerTwinAng360, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("thickness"), py::arg("color1") = ImColor(0xffffffff), py::arg("color2") = ImColor(0xff0000ff), py::arg("speed1") = 2.8f, py::arg("speed2") = 2.5f);

    m.def("spinner_inc_dots",
        ImSpinner::SpinnerIncDots, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 6);

    m.def("spinner_inc_full_dots",
        ImSpinner::SpinnerIncFullDots, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 4);

    m.def("spinner_fade_bars",
        ImSpinner::SpinnerFadeBars, py::arg("label"), py::arg("w"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("bars") = 3, py::arg("scale") = false);

    m.def("spinner_bars_rotate_fade",
        ImSpinner::SpinnerBarsRotateFade, py::arg("label"), py::arg("rmin"), py::arg("rmax"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("bars") = 6);

    m.def("spinner_bars_scale_middle",
        ImSpinner::SpinnerBarsScaleMiddle, py::arg("label"), py::arg("w"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("bars") = 3);

    m.def("spinner_ang_twin",
        ImSpinner::SpinnerAngTwin, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI, py::arg("arcs") = 1);

    m.def("spinner_arc_rotation",
        ImSpinner::SpinnerArcRotation, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("arcs") = 4);

    m.def("spinner_arc_fade",
        ImSpinner::SpinnerArcFade, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("arcs") = 4);

    m.def("spinner_filled_arc_fade",
        ImSpinner::SpinnerFilledArcFade, py::arg("label"), py::arg("radius"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("arcs") = 4);

    m.def("spinner_filled_arc_color",
        ImSpinner::SpinnerFilledArcColor, py::arg("label"), py::arg("radius"), py::arg("color") = ImColor(0xffff0000), py::arg("bg") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("arcs") = 4);

    m.def("spinner_twin_ball",
        ImSpinner::SpinnerTwinBall, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("thickness"), py::arg("b_thickness"), py::arg("ball") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f, py::arg("balls") = 2);

    m.def("spinner_bounce_ball",
        ImSpinner::SpinnerBounceBall, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f);

    m.def("spinner_inc_scale_dots",
        ImSpinner::SpinnerIncScaleDots, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("dots") = 6);

    m.def("spinner_ang_triple",
        ImSpinner::SpinnerAngTriple, py::arg("label"), py::arg("radius1"), py::arg("radius2"), py::arg("radius3"), py::arg("thickness"), py::arg("c1") = ImColor(0xffffffff), py::arg("c2") = ImColor(0xffffff80), py::arg("c3") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI);

    m.def("spinner_ang_eclipse",
        ImSpinner::SpinnerAngEclipse, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI);

    m.def("spinner_ing_yang",
        ImSpinner::SpinnerIngYang, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("reverse"), py::arg("yang_detlta_r"), py::arg("color_i") = ImColor(0xffffffff), py::arg("color_y") = ImColor(0xffffffff), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI * 0.7f);

    m.def("spinner_gooey_balls",
        ImSpinner::SpinnerGooeyBalls, py::arg("label"), py::arg("radius"), py::arg("color"), py::arg("speed"));

    m.def("spinner_rotate_gooey_balls",
        ImSpinner::SpinnerRotateGooeyBalls, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color"), py::arg("speed"), py::arg("balls"));

    m.def("spinner_moon_line",
        ImSpinner::SpinnerMoonLine, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xff000000), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI);

    m.def("spinner_circle_drop",
        ImSpinner::SpinnerCircleDrop, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("thickness_drop"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f, py::arg("angle") = IM_PI);

    m.def("spinner_surrounded_indicator",
        ImSpinner::SpinnerSurroundedIndicator, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f);

    m.def("spinner_triangles_seletor",
        ImSpinner::SpinnerTrianglesSeletor, py::arg("label"), py::arg("radius"), py::arg("thickness"), py::arg("color") = ImColor(0xffffffff), py::arg("bg") = ImColor(0xffffff80), py::arg("speed") = 2.8f, py::arg("bars") = 8);
    // #endif
    ////////////////////    </generated_from:imspinner.h>    ////////////////////

    // </litgen_pydef> // Autogenerated code end
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
}
